IncludeFile "vars_Structs.pb"

Procedure.l GetDriveHandle(drv.s)
;get the handle with CreateFile().
;you can access drives with "\\.\X:", where X is the drive's char.
ProcedureReturn CreateFile_("\\.\" + drv + ":", #GENERIC_READ | #GENERIC_WRITE, #FILE_SHARE_READ | #FILE_SHARE_WRITE, 0, #OPEN_EXISTING, #FILE_ATTRIBUTE_NORMAL,0)
EndProcedure

Procedure.l SPTIAvailable()
pswb.t_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER: OL.t_OVERLAPPED
Length.l: returned.l: i.l
status.l:drv.s
;find the first CD/DVD-ROM drive
For i = 1 To 26
	If GetDriveType_(Chr(i + 64) + ":") = 5
		drv = Chr(i + 64)
		Break
	EndIf
Next
;get its drive handle
fh.l = GetDriveHandle(drv)
If fh = 0: ProcedureReturn 0: EndIf

With pswb\spt
	\senseInfoOffset = OffsetOf(t_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER\SenseBuffer)  ; Sense Info Offset
	\senseInfoLength = SizeOf(pswb\SenseBuffer)-1        ; Sense Info size
	\DataIn = #SCSI_IOCTL_DATA_IN                       ; data direction
	\TimeOutValue = 10                                 ; Timeout
	\CdbLength = 6                                     ; CDB length
	\length = 44                                       ; size of the substructure
EndWith
Length = SizeOf(pswb)                                     ; size of the structure

status = DeviceIoControl_(fh, IOCTL_SCSI_PASS_THROUGH_DIRECT, @pswb, Length, @pswb, Length, @returned, @OL)
;success?
If status = 1
	ProcedureReturn 1
Else
	ProcedureReturn 0
EndIf
EndProcedure

;HA:ID from drive char (NT/2K/XP)
Procedure.l SPTIGetHAID(strDrv.s, *haid.t_HAID)
returned.l: status.l
i.l
sd.SECURITY_ATTRIBUTES
pscsiAddr.t_SCSI_ADDRESS
OL.t_OVERLAPPED
;get drive handle
fh.l = GetDriveHandle(strDrv)
If fh = 0: ProcedureReturn 0: EndIf

pscsiAddr\Length = SizeOf(pscsiAddr)
status = DeviceIoControl_(fh, IOCTL_SCSI_GET_ADDRESS, @pscsiAddr, SizeOf(pscsiAddr), @pscsiAddr, SizeOf(pscsiAddr), @returned, @OL)
CloseHandle_(fh)
;success?
If status = 1 
	With pscsiAddr
		*haid\HA = \PortNumber
		*haid\ID = \TargetId
		ProcedureReturn 1
	EndWith
Else
	ProcedureReturn 0
EndIf
EndProcedure

;execute a command through the SPTI
Procedure.l SPTICmd(drv.s, Array cmd.b(1), CmdLen.w, WFE.l, eDir.l, Pointer.l, PointerLen.l, Timeout.l = 5)
pswb.t_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER: OL.t_OVERLAPPED
Length.l: returned.l: i.l
status.l
;get the drive's handle
fh.l = GetDriveHandle(drv)
If fh = 0: ProcedureReturn 0: EndIf
;check the timeout
If WFE: Timeout = 9999: ElseIf Timeout = 0: Timeout = 10: EndIf

With pswb\spt
	\length = 44                                       ; size of the substructure
	\DataIn = eDir                                     ; data dir
	\TimeOutValue = Timeout                            ; Timeout
	\senseInfoLength = SizeOf(pswb\SenseBuffer)-1      ; Sense Info size
	\senseInfoOffset = OffsetOf(t_SCSI_PASS_THROUGH_DIRECT_WITH_BUFFER\SenseBuffer) ; Sense Info Offset
	\DataTransferLength = PointerLen                   ; data len
	\DataBuffer = Pointer                              ; data buffer pointer
	For i = 0 To CmdLen - 1
		\Cdb[i] = cmd(i)
	Next i  ; CDB from Array
	\CdbLength = CmdLen                                ; CDB len
EndWith
Length = SizeOf(pswb)                                ; size of the structure
;SPTD
status = DeviceIoControl_(fh, IOCTL_SCSI_PASS_THROUGH_DIRECT, @pswb, Length, @pswb, Length, @returned, @OL)
;close the drive's handle
CloseHandle_(fh)
;success?
If status = 1 And pswb\spt\ScsiStatus = 0
	ProcedureReturn 1
Else
	ProcedureReturn 0
EndIf
EndProcedure
; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 50
; FirstLine = 45
; Folding = -
; EnableXP